#!/usr/bin/lua
--
-- v0.1
--
-- Reading data from stdin or from file, specified in the first parameter
require"string"
require"io"
require"os"

local keys =	{	Name=1,
					Comment=1}

local df = io.stdin
if arg[1] ~= nil then
  df = io.open(arg[1], 'r')
end
local line, k, v, group=nil
local xgettext = io.popen( 'xgettext -L C --no-location --keyword=C_:1c,2 -o - -', 'w')
while true do
  line = df:read("*line")
  if not line then break end
  -- searching group name
  v = string.match(line, '^%[(.*)%]')
  if v then
    group = v
  else
    -- searching key - value pair
    k,v = string.match(line, '^([%w-]+)%s*=%s*(.*)')
    if keys[k] then
       if group == nil then
         io.stderr:write("Invalid file format: no group\n")
         os.exit(1)
       end
       --print( 'str = C_("'..group..'/'..k..'",'..v..'");' )
       xgettext:write( 'str = C_("'..group..'/'..k..'","'..v..'");\n' )
    end
  end
end
xgettext:close()
if arg[1] ~= nil then df:close() end
