#!/usr/bin/lua
--
-- v0.1
--
require"string"
require"io"
require"os"
require"table"

local line, k, v, group, _group, _k

local translations = {}

local pofilename =arg[1]
local desktopfilename = arg[2]
local language = arg[3]
if pofilename ==nil and desktopfilename ==nil and language==nil then
  print('Usage: po2desktop.lua po-file desktop-file language')
  os.exit(1)
end

local pf = io.open(pofilename, 'r')
local df = io.open(desktopfilename, 'r')
-- processing translations
while true do
  line = pf:read("*line")
  if not line then break end
  --print(line)
  _group, _k = string.match(line, '^msgctxt "(.*)/(.*)"$')
  if _group and _k then 
    group, k = _group, _k
  else
    v = string.match(line, '^msgstr "(.*)"$')
    --print(group, k, v)
    if v ~= nil and group ~= nil and k ~= nil then
      translations[group] = translations[group] or {}
      translations[group][k] = v
    end
  end
end
pf:close()
-- updating original
while true do
  line = df:read("*line")
  if not line then break end
  -- searching group name
  v = string.match(line, '^%[(.*)%]')
  if v then
    group = v
    print(line)
  else
    k,v = string.match(line, '^([%w-%[%]]+)%s*=%s*(.*)')
    --if k then print('"'..k..'"','"'..v..'"') end
    if k and v then
      if group == nil then
         io.stderr:write("Invalid file format: no group\n")
         os.exit(1)
      end
      -- try to extract language
      local _k, _lang = string.match(k, '^(%w+)%[(.*)%]')
      --print("XXXXXXXXXXXXX", k, _k, _lang)
      if _k and _lang == language and translations[group][_k] then
        if translations[group][_k..'_insert'] == nil then
          print(k..'='..translations[group][_k])
          translations[group][_k..'_insert'] = true
        end
      elseif translations[group][k] then
        print(line)
        if translations[group][k..'_insert'] == nil then
          print(k..'['..language..']='..translations[group][k])
          translations[group][k..'_insert'] = true
        end
      else
        print(line)
      end
    else
      print(line)
    end
  end
end
--[=[
for group, a in pairs(translations) do
  for k,v in pairs(a) do
    print(group, k, v)
  end
end
]=]
df:close()
